﻿Public Class Form1
    Dim Tablero(3, 3) As Integer
    Dim Jugador As Integer = 1

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Dim F As Integer
        Dim C As Integer

        ' Fer un bucle per posar-ho tot a 0
        For F = 1 To 3
            For C = 1 To 3
                Tablero(F, C) = 0
            Next
        Next

    End Sub

 
    Private Sub PictureBox1_Click(sender As Object, e As EventArgs) Handles PictureBox1.Click, PictureBox2.Click, PictureBox3.Click, PictureBox9.Click, PictureBox8.Click, PictureBox7.Click, PictureBox6.Click, PictureBox5.Click, PictureBox4.Click
        Dim pic As PictureBox = sender
        Dim Fila As Integer
        Dim Columna As Integer
        Dim NomFoto As String



        ' Mirar quina fila i columna estem treballant
        If pic.Name = "PictureBox1" Then Fila = 1 : Columna = 1
        If pic.Name = "PictureBox2" Then Fila = 1 : Columna = 2
        If pic.Name = "PictureBox3" Then Fila = 1 : Columna = 3
        If pic.Name = "PictureBox4" Then Fila = 2 : Columna = 1
        If pic.Name = "PictureBox5" Then Fila = 2 : Columna = 2
        If pic.Name = "PictureBox6" Then Fila = 2 : Columna = 3
        If pic.Name = "PictureBox7" Then Fila = 3 : Columna = 1
        If pic.Name = "PictureBox8" Then Fila = 3 : Columna = 2
        If pic.Name = "PictureBox9" Then Fila = 3 : Columna = 3

        ' Mirar si el tablero es ocupat
        If Tablero(Fila, Columna) <> 0 Then
            Exit Sub
        End If

        ' Posar la fitxa dins del tablero
        Tablero(Fila, Columna) = Jugador

        ' Mostar la fitxa en el tablero visual
        NomFoto = Application.StartupPath & "\imatges\tres" & Jugador & ".png"
        pic.Image = Image.FromFile(NomFoto)

        ' Mirar si ha guanyat la partida
        '*****************************************************************************

        ' Si has guanyat es cert, voldria dir que s'ha acabat el joc
        If HasGuanyat(Jugador) = True Then
            MsgBox("Ha guanyat el jugador : " & Jugador)
            Reinicialitzar()
            Exit Sub
        End If

        ' Son taules
        If SonTaules() = True Then
            MsgBox("Partida en taules")
            Reinicialitzar()
            Exit Sub
        End If

        ' Canviar de jugador (2 = ordinador)
        '************************************
        If Jugador = 1 Then
            Jugador = 2

            ' Només tirar el ordinador, si esta actiu el checked
            If CheckBox1.Checked = True Then
                TiradaOrdinador()
            End If

        Else
            Jugador = 1
        End If

        ' Mostrar el jugador que li toca tirar
        labelJugador.Text = Jugador

    End Sub

    '***************************************************************
    ' Procediment per fer el Reset de l'aplicacio
    '***************************************************************
    Private Sub Reinicialitzar()
        Dim Y As Integer
        Dim X As Integer
        Dim r As MsgBoxResult

        ' Preguntar si volem tornar a jugar
        r = MsgBox("Vols Tornar a jugar?", MsgBoxStyle.YesNo + MsgBoxStyle.Information)

        If r = MsgBoxResult.No Then
            End
        End If


        ' Toranar a cero tot el tablero
        For Y = 1 To 3
            For X = 1 To 3
                Tablero(Y, X) = 0
            Next
        Next

        ' Definir el jugador inicial
        Jugador = 1

        ' Definir el label del jugador inicial
        labelJugador.Text = Jugador

        ' Buidar totes les imatges del picturebox
        PictureBox1.Image = Nothing
        PictureBox2.Image = Nothing
        PictureBox3.Image = Nothing
        PictureBox4.Image = Nothing
        PictureBox5.Image = Nothing
        PictureBox6.Image = Nothing
        PictureBox7.Image = Nothing
        PictureBox8.Image = Nothing
        PictureBox9.Image = Nothing

    End Sub

    '*************************************************************
    '* Crear la funcio per mirar si son taules
    '*************************************************************
    Private Function SonTaules() As Boolean
        Dim x, y As Integer
        Dim Taules As Boolean = True

        ' Hi ha taules?
        For y = 1 To 3
            For x = 1 To 3
                If Tablero(y, x) = 0 Then Taules = False
            Next
        Next

        ' Retornar el valor
        Return Taules
    End Function

    '**********************************************************
    ' Crear la funcio per mirar si ha guanyat un jugador
    '**********************************************************
    Private Function HasGuanyat(jug As Integer) As Boolean
        Dim Guanyat As Boolean = False

        ' Mirar si s'ha fet tres en linea
        If Tablero(1, 1) = jug And Tablero(1, 2) = jug And Tablero(1, 3) = jug Then Guanyat = True
        If Tablero(2, 1) = jug And Tablero(2, 2) = jug And Tablero(2, 3) = jug Then Guanyat = True
        If Tablero(3, 1) = jug And Tablero(3, 2) = jug And Tablero(3, 3) = jug Then Guanyat = True

        If Tablero(1, 1) = jug And Tablero(2, 1) = jug And Tablero(3, 1) = jug Then Guanyat = True
        If Tablero(1, 2) = jug And Tablero(2, 2) = jug And Tablero(3, 2) = jug Then Guanyat = True
        If Tablero(1, 3) = jug And Tablero(2, 3) = jug And Tablero(3, 3) = jug Then Guanyat = True

        If Tablero(1, 1) = jug And Tablero(2, 2) = jug And Tablero(3, 3) = jug Then Guanyat = True
        If Tablero(3, 1) = jug And Tablero(2, 2) = jug And Tablero(1, 3) = jug Then Guanyat = True

        ' Retornar el valor
        Return Guanyat

    End Function

    '**********************************************************
    ' Crear el Procediment de la Tirada de la maquina
    '**********************************************************
    Private Sub TiradaOrdinador()
        Dim Y, X As Integer
        Dim N As New Random
        Dim Fila As Integer
        Dim Columna As Integer

        ' Mirar si podem fer tres en linia
        For Y = 1 To 3
            For X = 1 To 3

                ' Mirar si es una posicio amb cero
                If Tablero(Y, X) = 0 Then
                    ' Simular possant una fitxa
                    Tablero(Y, X) = 2

                    ' He fet 3 en linea?
                    If HasGuanyat(2) = True Then
                        PosarFitxaOrdinador(Y, X)
                        MsgBox("Ha guanyat el jugador : " & Jugador)
                        Reinicialitzar()
                        Exit Sub
                    End If

                    ' Tornar la posicio a cero
                    Tablero(Y, X) = 0

                End If
            Next
        Next

        ' Mirar si pot fer tres en linia el jugador 1
        For Y = 1 To 3
            For X = 1 To 3

                ' Mirar si es una posicio amb cero
                If Tablero(Y, X) = 0 Then
                    ' Simular possant una fitxa
                    Tablero(Y, X) = 1

                    ' He fet 3 en linea?
                    If HasGuanyat(1) = True Then
                        ' Posar la meva fitxa en el seu lloc
                        PosarFitxaOrdinador(Y, X)
                        Tablero(Y, X) = 2
                        Jugador = 1
                        labelJugador.Text = Jugador
                        Exit Sub
                    End If

                    ' Tornar la posicio a cero
                    Tablero(Y, X) = 0

                End If
            Next
        Next

        ' Buscar una posicio lliure al atzar
        While (1)

            ' Pensar un numero al atzar
            Fila = N.Next(1, 4)
            Columna = N.Next(1, 4)

            ' Esta lliure la posició?
            If Tablero(Fila, Columna) = 0 Then
                ' Posar la meva fitxa en el seu lloc
                PosarFitxaOrdinador(Fila, Columna)
                Tablero(Fila, Columna) = 2
                Jugador = 1
                labelJugador.Text = Jugador
                Exit Sub
            End If

        End While

    End Sub

    '**********************************************************
    ' Posar la fitxa en la pantalla del Ordinador
    '**********************************************************
    Private Sub PosarFitxaOrdinador(Fila As Integer, Columna As Integer)
        Dim NomFoto As String

        ' Mostar la fitxa en el tablero visual
        NomFoto = Application.StartupPath & "\imatges\tres2.png"

        ' Mirar on posar la imatge
        If Fila = 1 And Columna = 1 Then PictureBox1.Image = Image.FromFile(NomFoto)
        If Fila = 1 And Columna = 2 Then PictureBox2.Image = Image.FromFile(NomFoto)
        If Fila = 1 And Columna = 3 Then PictureBox3.Image = Image.FromFile(NomFoto)
        If Fila = 2 And Columna = 1 Then PictureBox4.Image = Image.FromFile(NomFoto)
        If Fila = 2 And Columna = 2 Then PictureBox5.Image = Image.FromFile(NomFoto)
        If Fila = 2 And Columna = 3 Then PictureBox6.Image = Image.FromFile(NomFoto)
        If Fila = 3 And Columna = 1 Then PictureBox7.Image = Image.FromFile(NomFoto)
        If Fila = 3 And Columna = 2 Then PictureBox8.Image = Image.FromFile(NomFoto)
        If Fila = 3 And Columna = 3 Then PictureBox9.Image = Image.FromFile(NomFoto)

    End Sub
End Class
